## ros-iron-mavros 2.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(mavros)

# Default to C++20
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 20)
  #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++2a")
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # we dont use add_compile_options with pedantic in message packages
  # because the Python C extensions dont comply with it
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcomment")

# Allow GNU extensions (-std=gnu++20)
set(CMAKE_C_EXTENSIONS ON)
set(CMAKE_CXX_EXTENSIONS ON)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)

# find mavros dependencies
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rcpputils REQUIRED)
find_package(message_filters REQUIRED)

find_package(mavlink REQUIRED)
find_package(libmavconn REQUIRED)
find_package(console_bridge REQUIRED)
#find_package(rosconsole_bridge REQUIRED)  # XXX TODO: connect libmavconn loggers

find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3 REQUIRED)

## Find GeographicLib
# Append to CMAKE_MODULE_PATH since debian/ubuntu installs
# FindGeographicLib.cmake in a nonstand location
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};/usr/share/cmake/geographiclib")
find_package(GeographicLib REQUIRED)

find_package(angles REQUIRED)
find_package(eigen_stl_containers REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(tf2_ros REQUIRED)

find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)

find_package(geographic_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(mavros_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)
find_package(trajectory_msgs REQUIRED)

include_directories(
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

include_directories(
  ${mavlink_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
  ${GeographicLib_INCLUDE_DIRS}
)

## Check if the datasets are installed
include(CheckGeographicLibDatasets)

if(rclcpp_VERSION VERSION_LESS 9.0.0)
  add_definitions(
    -DUSE_OLD_DECLARE_PARAMETER
  )
endif()

# [[[cog:
# import mavros_cog
# ]]]
# [[[end]]] (checksum: d41d8cd98f00b204e9800998ecf8427e)

add_library(mavros SHARED
  # [[[cog:
  # mavros_cog.outl_glob_files('src/lib')
  # ]]]
  src/lib/enum_sensor_orientation.cpp
  src/lib/enum_to_string.cpp
  src/lib/ftf_frame_conversions.cpp
  src/lib/ftf_quaternion_utils.cpp
  src/lib/mavros_router.cpp
  src/lib/mavros_uas.cpp
  src/lib/plugin.cpp
  src/lib/uas_ap.cpp
  src/lib/uas_data.cpp
  src/lib/uas_executor.cpp
  src/lib/uas_stringify.cpp
  src/lib/uas_tf.cpp
  src/lib/uas_timesync.cpp
  # [[[end]]] (checksum: 3239d16fc87982964694f18425f297b1)
)
ament_target_dependencies(mavros
  rclcpp
  rclcpp_components
  rcpputils
  #class_loader
  sensor_msgs
  pluginlib
  mavros_msgs
  libmavconn
  #console_bridge
  diagnostic_updater
  tf2_ros
  tf2_eigen
  Eigen3
)
target_link_libraries(mavros ${GeographicLib_LIBRARIES})
rclcpp_components_register_nodes(mavros "mavros::router::Router" "mavros::uas::UAS")

add_library(mavros_plugins SHARED
  # [[[cog:
  # mavros_cog.outl_glob_files('src/plugins')
  # ]]]
  src/plugins/actuator_control.cpp
  src/plugins/altitude.cpp
  src/plugins/command.cpp
  src/plugins/dummy.cpp
  src/plugins/ftp.cpp
  src/plugins/geofence.cpp
  src/plugins/global_position.cpp
  src/plugins/home_position.cpp
  src/plugins/imu.cpp
  src/plugins/local_position.cpp
  src/plugins/manual_control.cpp
  src/plugins/mission_protocol_base.cpp
  src/plugins/nav_controller_output.cpp
  src/plugins/param.cpp
  src/plugins/rallypoint.cpp
  src/plugins/rc_io.cpp
  src/plugins/setpoint_accel.cpp
  src/plugins/setpoint_attitude.cpp
  src/plugins/setpoint_position.cpp
  src/plugins/setpoint_raw.cpp
  src/plugins/setpoint_trajectory.cpp
  src/plugins/setpoint_velocity.cpp
  src/plugins/sys_status.cpp
  src/plugins/sys_time.cpp
  src/plugins/waypoint.cpp
  src/plugins/wind_estimation.cpp
  # [[[end]]] (checksum: ccf56c1a56e9dccf8464483f7b1eab99)
)
add_dependencies(mavros_plugins
  mavros
)
target_link_libraries(mavros_plugins
  mavros
)
ament_target_dependencies(mavros_plugins
  angles
  geometry_msgs
  geographic_msgs
  mavros_msgs
  std_msgs
  std_srvs
  sensor_msgs
  pluginlib
  nav_msgs
  trajectory_msgs
  rclcpp
  rclcpp_components
  rcpputils
  libmavconn
  diagnostic_updater
  tf2_ros
  tf2_eigen
  message_filters
  Eigen3
)
pluginlib_export_plugin_description_file(mavros mavros_plugins.xml)

add_executable(mavros_node src/mavros_node.cpp)
target_link_libraries(mavros_node mavros)

ament_python_install_package(${PROJECT_NAME})

# NOTE(vooon): for some reason console_scripts do not work with ament_python!
install(PROGRAMS scripts/mav
  DESTINATION lib/${PROJECT_NAME}
)

install(TARGETS mavros mavros_node mavros_plugins
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

install(PROGRAMS scripts/install_geographiclib_datasets.sh
  DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/
  DESTINATION include
)

install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_pytest REQUIRED)

  # NOTE(vooon): explicit call to find dependencies for ament_lint
  # ament_find_gtest()
  # ament_find_gmock()

  # NOTE(vooon): without that cppcheck fails on tests cpp files
  # list(APPEND ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS "${GMOCK_INCLUDE_DIRS}")
  # list(APPEND ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS "${GTEST_INCLUDE_DIRS}")
  # list(APPEND ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS "${EIGEN3_INCLUDE_DIRS}")
  # set(ament_cmake_cppcheck_LANGUAGE "c++")

  # NOTE(vooon): tired to provide more and more macro
  list(APPEND ament_cmake_cppcheck_ADDITIONAL_EXCLUDE "./test/*.cpp")

  # NOTE(vooon): cpplint complains about generated lines too long. Nothing more.
  # XXX(vooon): don't work for Foxy!
  # list(APPEND ament_cmake_cpplint_ADDITIONAL_EXCLUDE "./src/lib/enum_to_string.cpp")

  find_package(ament_lint_auto REQUIRED)

  # NOTE(vooon): Does not support our custom triple-license, tiered to make it to work.
  list(APPEND AMENT_LINT_AUTO_EXCLUDE ament_cmake_copyright)

  ament_lint_auto_find_test_dependencies()

  ament_add_gtest(libmavros-frame-conversions-test test/test_frame_conversions.cpp)
  target_link_libraries(libmavros-frame-conversions-test mavros)
  #ament_target_dependencies(libmavros-frame-conversions-test mavros)

  ament_add_gtest(libmavros-sensor-orientation-test test/test_sensor_orientation.cpp)
  target_link_libraries(libmavros-sensor-orientation-test mavros)
  #ament_target_dependencies(libmavros-sensor-orientation-test mavros)

  ament_add_gtest(libmavros-quaternion-utils-test test/test_quaternion_utils.cpp)
  target_link_libraries(libmavros-quaternion-utils-test mavros)
  #ament_target_dependencies(libmavros-quaternion-utils-test mavros)

  ament_add_gmock(mavros-router-test test/test_router.cpp)
  target_link_libraries(mavros-router-test mavros)
  ament_target_dependencies(mavros-router-test mavros_msgs)

  ament_add_gmock(mavros-uas-test test/test_uas.cpp)
  target_link_libraries(mavros-uas-test mavros)
  ament_target_dependencies(mavros-uas-test mavros_msgs)

  ament_add_pytest_test(mavros_py_test test/mavros_py
    PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}"
    APPEND_ENV PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}
  )
endif()

#ament_export_dependencies(console_bridge)
ament_export_include_directories(include)
ament_export_libraries(mavros)
ament_export_dependencies(eigen3_cmake_module)
ament_export_dependencies(Eigen3)
#ament_export_targets(mavros_node)
ament_package()

# vim: ts=2 sw=2 et:

=== debian/changelog ===
ros-iron-mavros (2.6.0-1jammy) jammy; urgency=high

  * fix build warnings tf2_eigen.h
  * switch to use tf2_eigen.hpp, but that drops support for EOL distros
  * fix ament_cpplint
  * reformat python code with black
  * msgs: move generator code
  * ament uncrustify
  * Merge branch 'master' into ros2
    * master:
    1.17.0
    update changelog
    cog: regenerate all
    Bugfix/update map origin with home position (#1892 <https://github.com/mavlink/mavros/issues/1892>)
    mavros: Remove extra ';'
    mavros_extras: Fix some init order warnings
    Suppress warnings from included headers
    1.16.0
    update changelog
    made it such that the gp_origin topic published latched.
    use hpp instead of deprecated .h pluginlib headers
  * 1.17.0
  * update changelog
  * cog: regenerate all
  * local takeoff and land topics (#1890 <https://github.com/mavlink/mavros/issues/1890>)
    * local takeoff and land topics
    * vector3 position type, rename to TOLLocal
    * remove auto include line
  * Bugfix/update map origin with home position (#1892 <https://github.com/mavlink/mavros/issues/1892>)
    * Update map origin with home position
    * Uncrustify
    * Revert "Uncrustify"
    This reverts commit f1387c79c7670cc241986586436e3da43842e877.
    * Change to relative topic
    ---------
    Co-authored-by: Natalia Molina <mailto:molina-munoz@wingcopter.com>
  * Merge pull request #1865 <https://github.com/mavlink/mavros/issues/1865> from scoutdi/warnings
    Fix / suppress some build warnings
  * mavros: Remove extra ';'
  * Suppress warnings from included headers
  * 1.16.0
  * update changelog
  * Merge pull request #1829 <https://github.com/mavlink/mavros/issues/1829> from snwu1996/latched_gp_origin_pub
    Made it such that the gp_origin topic publisher is latched.
  * made it such that the gp_origin topic published latched.
  * Merge pull request #1817 <https://github.com/mavlink/mavros/issues/1817> from lucasw/pluginlib_hpp
    use hpp instead of deprecated .h pluginlib headers
  * use hpp instead of deprecated .h pluginlib headers
  * Contributors: Ido Guzi, Lucas Walter, Morten Fyhn Amundsen, Shu-Nong Wu, Vladimir Ermakov, natmol

 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 09 Sep 2023 00:00:00 -0000

ros-iron-mavros (2.5.0-1jammy) jammy; urgency=high

  * Merge pull request #1852 <https://github.com/mavlink/mavros/issues/1852> from robobe/fix-mavlink-header-stamp
    Fix mavlink header stamp in convert_to_rosmsg method
  * Delete test_convert_to_rosmsg.py
  * fix flake8
  * fix flake8
  * fix conver_to_rosmsg method
    fix header stamp field
    move from rclpy.Time to
    builtin_interfaces Time message
  * Merge branch 'mavlink_payload64_fix' into ros2
  * Merge pull request #1851 <https://github.com/mavlink/mavros/issues/1851> from robobe/mavlink_payload64_fix
    cast payload_octest to int
  * cast payload_octest to int
    test script ,
  * Merge pull request #1838 <https://github.com/mavlink/mavros/issues/1838> from vacabun/launch_namespace_fix
    fix ROS2 launch parameters namespace and name.
  * fix plugin denylist allowlist name, and fix parameters namespace.
  * Merge pull request #1835 <https://github.com/mavlink/mavros/issues/1835> from vacabun/multi_uas_launch_fix
    Multi-UAS launch
  * Merge branch 'ros2' into multi_uas_launch_fix
  * Merge pull request #1836 <https://github.com/mavlink/mavros/issues/1836> from eMrazSVK/ros2
    Fix apm_pluginlist.yaml and apm.launch
  * naming
  * Fix apm config and launch ROS2
  * Remove duplicate parameters
  * fix parameters name tgt_system and tgt_component and add multi-uas launch.
  * Merge pull request #1834 <https://github.com/mavlink/mavros/issues/1834> from vacabun/px4_launch_fix
    fix px4 launch file for ROS2
  * change plugin odom parameters in apm launch.
  * 1.Change part of parameters to be flat In ROS2.
    2.Remove plugin safety_area in launch parameters file.
  * remove event_launcher.yaml mavlink_bridge.launch
  * remove file 'apm2.lunch'.
  * fix apm launch files to ROS2.
  * fix plugin distance_sensor parses yaml from string parameter.
  * fix px4 launch file on ROS2.
  * Merge pull request #1833 <https://github.com/mavlink/mavros/issues/1833> from lopsided98/ftp-segfault
    plugins: ftp: fix null pointer dereference
  * plugins: ftp: fix null pointer dereference
    df4e529 mistakenly switched PayloadHeader::data from using a non-standards
    compliant (but accepted by most compilers) flexible array to a pointer. This
    resulted in an attempt to dereference the uninitialized contents of the array.
    This patch eliminates PayloadHeader::data and instead makes FTPRequest::data()
    use pointer arithmetic to get the data buffer from within the payload buffer.
  * Contributors: Ben Wolsieffer, Eduard Mraz, Vladimir Ermakov, robo, robobe, vacabun

 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 05 May 2023 00:00:00 -0000

ros-iron-mavros (2.4.0-1jammy) jammy; urgency=high

  * ci: ignore xml lib warn
  * Merge branch 'master' into ros2
    * master:
    1.15.0
    update changelog
    ci: update actions
    Implement debug float array handler
    mavros_extras: Fix a sequence point warning
    mavros_extras: Fix a comparison that shouldn't be bitwise
    mavros: Fix some warnings
    mavros_extras: Fix buggy check for lat/lon ignored
    libmavconn: fix MAVLink v1.0 output selection
  * 1.15.0
  * update changelog
  * Merge pull request #1806 <https://github.com/mavlink/mavros/issues/1806> from scoutdi/fix-some-warnings
    mavros: Fix some warnings
  * mavros: Fix some warnings
  * Contributors: Morten Fyhn Amundsen, Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 30 Dec 2022 00:00:00 -0000

ros-iron-mavros (2.3.0-1jammy) jammy; urgency=high

  * extras: fix linter errors
  * mavros: remove custom find script, re-generate
  * Merge branch 'master' into ros2
    * master:
    1.14.0
    update changelog
    scripts: waypoint and param files are text, not binary


=== debian/control ===
Source: ros-iron-mavros
Section: misc
Priority: optional
Maintainer: Vladimir Ermakov <vooon341@gmail.com>
Build-Depends: debhelper (>= 9.0.0), geographiclib-tools, google-mock <!nocheck>, libconsole-bridge-dev, libeigen3-dev, libgeographic-dev, libgtest-dev <!nocheck>, ros-iron-ament-cmake, ros-iron-ament-cmake-gmock <!nocheck>, ros-iron-ament-cmake-gtest <!nocheck>, ros-iron-ament-cmake-pytest <!nocheck>, ros-iron-ament-cmake-python, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-angles, ros-iron-diagnostic-msgs, ros-iron-diagnostic-updater, ros-iron-eigen-stl-containers, ros-iron-eigen3-cmake-module, ros-iron-geographic-msgs, ros-iron-geometry-msgs, ros-iron-libmavconn, ros-iron-mavlink, ros-iron-mavros-msgs, ros-iron-message-filters, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-rcpputils, ros-iron-sensor-msgs, ros-iron-std-msgs, ros-iron-std-srvs, ros-iron-tf2-eigen, ros-iron-tf2-ros, ros-iron-trajectory-msgs, ros-iron-ros-workspace
Homepage: http://wiki.ros.org/mavros
Standards-Version: 3.9.2

Package: ros-iron-mavros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, geographiclib-tools, libconsole-bridge-dev, libeigen3-dev, libgeographic-dev, python3-click, ros-iron-diagnostic-msgs, ros-iron-diagnostic-updater, ros-iron-eigen-stl-containers, ros-iron-eigen3-cmake-module, ros-iron-geographic-msgs, ros-iron-geometry-msgs, ros-iron-libmavconn, ros-iron-mavlink, ros-iron-mavros-msgs, ros-iron-message-filters, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-rclpy, ros-iron-rcpputils, ros-iron-rosidl-default-runtime, ros-iron-sensor-msgs, ros-iron-std-msgs, ros-iron-std-srvs, ros-iron-tf2-eigen, ros-iron-tf2-ros, ros-iron-trajectory-msgs, ros-iron-ros-workspace
Description: MAVROS -- MAVLink extendable communication node for ROS with proxy for Ground Control Station.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-mavros//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
